'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _nukeCore = require('nuke-core');

function valueToObj(obj) {
  Object.keys(obj).forEach(function (name) {
    if (_typeof(obj[name]) === 'object') {
      obj[name] = {
        name: name,
        raw: obj[name]
      };
    }
  });
  return obj;
}

function buttonColor(color, activeColor, bgColor, activeBgColor, borderColor, activeBorderColor, opacity) {
  return valueToObj(Object.assign({
    color: color,
    backgroundColor: bgColor,
    borderColor: borderColor,
    'color:active': activeColor,
    'backgroundColor:active': activeBgColor,
    'borderColor:active': activeBorderColor
  }, opacity ? { opacity: opacity } : {}));
}

function buttonSize() {
  var pd = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var height = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var fontSize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var iconSize = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var iconMargin = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
  var corner = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
  var borderWidth = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 0;

  return valueToObj(_extends({
    height: height
  }, (0, _nukeCore.padding)(0, pd), {
    fontSize: fontSize,
    borderRadius: corner,
    borderWidth: borderWidth
  }));
}

function buttonDisabled(disabledColor, disabledBgColor, disabledBorderColor, disbledOpacity) {
  return valueToObj({
    color: disabledColor,
    backgroundColor: disabledBgColor,
    borderColor: disabledBorderColor,
    opacity: disbledOpacity,
    'color:active': disabledColor,
    'backgroundColor:active': disabledBgColor,
    'borderColor:active': disabledBorderColor
  });
}

module.exports = {
  buttonColor: buttonColor,
  buttonSize: buttonSize,
  buttonDisabled: buttonDisabled
};