'use strict';

var _nukeCore = require('nuke-core');

function VariableMix(theme) {
  var Core = theme.Core;
  var ComponentCustomStyle = theme.Button || {};

  /**
   * 按钮
   * @namespace component
   * @property module button
   * @property tag Button
   * @property category component
   */

  var buttonVariables = {
    /**
     * height
     * @property namespace size/bounding
     */
    'size-s-height': (0, _nukeCore.vLoader)(Core['s-7']),
    /**
     * height
     * @property namespace size/bounding
     */
    'size-m-height': (0, _nukeCore.vLoader)(Core['s-8']),
    /**
     * height
     * @property namespace size/bounding
     */
    'size-l-height': (0, _nukeCore.vLoader)(Core['s-12']),
    /**
     * padding(l, r)
     * @property namespace size/bounding
     */
    'size-s-padding-lr': (0, _nukeCore.vLoader)(Core['s-4']),
    /**
     * padding(l, r)
     * @property namespace size/bounding
     */
    'size-m-padding-lr': (0, _nukeCore.vLoader)(Core['s-5']),
    /**
     * padding(l, r)
     * @property namespace size/bounding
     */
    'size-l-padding-lr': (0, _nukeCore.vLoader)(Core['s-5']),
    /**
     * text
     * @property namespace size/text
     */
    'size-l-font': (0, _nukeCore.vLoader)(Core['font-size-subhead']),
    /**
     * text
     * @property namespace size/text
     */
    'size-m-font': (0, _nukeCore.vLoader)(Core['font-size-body-1']),
    /**
     * text
     * @property namespace size/text
     */
    'size-s-font': (0, _nukeCore.vLoader)(Core['font-size-caption']),
    /**
     * margin(l, r)
     * @property namespace size/icon
     */
    'icon-l-margin-lr': (0, _nukeCore.vLoader)(Core['s-2']),
    /**
     * margin(l, r)
     * @property namespace size/icon
     */
    'icon-m-margin-lr': (0, _nukeCore.vLoader)(Core['s-1']),
    /**
     * margin(l, r)
     * @property namespace size/icon
     */
    'icon-s-margin-lr': (0, _nukeCore.vLoader)(Core['s-1']),
    /**
     * size
     * @property namespace size/icon
     */
    'icon-size-l': (0, _nukeCore.vLoader)(Core['icon-s']),
    /**
     * size
     * @property namespace size/icon
     */
    'icon-size-m': (0, _nukeCore.vLoader)(Core['icon-xs']),
    /**
     * size
     * @property namespace size/icon
     */
    'icon-size-s': (0, _nukeCore.vLoader)(Core['icon-xs']),
    /**
     * corner
     * @property namespace statement/normal
     */
    'corner-l': (0, _nukeCore.vLoader)(Core['corner-1']),
    /**
     * corner
     * @property namespace statement/normal
     */
    'corner-m': (0, _nukeCore.vLoader)(Core['corner-1']),
    /**
     * corner
     * @property namespace statement/normal
     */
    'corner-s': (0, _nukeCore.vLoader)(Core['corner-1']),
    /**
     * width
     * @property namespace size/border
     */
    'border-width-l': (0, _nukeCore.vLoader)(Core['line-1']),
    /**
     * width
     * @property namespace size/border
     */
    'border-width-m': (0, _nukeCore.vLoader)(Core['line-1']),
    /**
     * width
     * @property namespace size/border
     */
    'border-width-s': (0, _nukeCore.vLoader)(Core['line-1']),
    /**
     * border-style
     * @property namespace statement
     */
    'normal-line-style': (0, _nukeCore.vLoader)(Core['line-solid']),
    /**
     * text
     * @property namespace statement/disabled
     */
    'normal-disabled-color': (0, _nukeCore.vLoader)(Core['color-text1-1']),
    /**
     * background
     * @property namespace statement/disabled
     */
    'normal-disabled-bg-color': (0, _nukeCore.vLoader)(Core['color-fill1-2']),
    /**
     * border
     * @property namespace statement/disabled
     */
    'normal-disabled-border-color': (0, _nukeCore.vLoader)(Core['color-line1-1']),
    /**
     * color
     * @property namespace statement/normal
     */
    'normal-color': (0, _nukeCore.vLoader)(Core['color-text1-3']),
    /**
     * background
     * @property namespace statement/normal
     */
    'normal-bg-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * border
     * @property namespace statement/normal
     */
    'normal-border-color': (0, _nukeCore.vLoader)(Core['color-line1-2']),
    /**
     * text
     * @property namespace statement/selected
     */
    'normal-active-color': (0, _nukeCore.vLoader)(Core['color-text1-3']),
    /**
     * border
     * @property namespace statement/selected
     */
    'normal-active-border-color': (0, _nukeCore.vLoader)(Core['color-line1-2']),
    /**
     * background
     * @property namespace statement/selected
     */
    'normal-active-bg-color': (0, _nukeCore.vLoader)(Core['color-fill1-2']),
    /**
     * text
     * @property namespace statement/normal
     */
    'prim-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * background
     * @property namespace statement/normal
     */
    'prim-bg-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * border
     * @property namespace statement/normal
     */
    'prim-border-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * text
     * @property namespace statement/selected
     */
    'prim-active-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * background
     * @property namespace statement/selected
     */
    'prim-active-bg-color': (0, _nukeCore.vLoader)(Core['color-brand1-9']),
    /**
     * border
     * @property namespace statement/selected
     */
    'prim-active-border-color': (0, _nukeCore.vLoader)(Core['color-brand1-9']),
    /**
     * text
     * @property namespace statement/disabled
     */
    'prim-disabled-color': (0, _nukeCore.vLoader)(Core['color-text1-1']),
    /**
     * background
     * @property namespace statement/disabled
     */
    'prim-disabled-bg-color': (0, _nukeCore.vLoader)(Core['color-fill1-2']),
    /**
     * border
     * @property namespace statement/disabled
     */
    'prim-disabled-border-color': (0, _nukeCore.vLoader)(Core['color-line1-1']),
    /**
     * text
     * @property namespace statement/normal
     */
    'second-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * background
     * @property namespace statement/normal
     */
    'second-bg-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * border
     * @property namespace statement/normal
     */
    'second-border-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * text
     * @property namespace statement/selected
     */
    'second-active-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * background
     * @property namespace statement/selected
     */
    'second-active-bg-color': (0, _nukeCore.vLoader)(Core['color-brand1-1']),
    /**
     * border
     * @property namespace statement/selected
     */
    'second-active-border-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * text
     * @property namespace statement/disabled
     */
    'second-disabled-color': (0, _nukeCore.vLoader)(Core['color-text1-1']),
    /**
     * background
     * @property namespace statement/disabled
     */
    'second-disabled-bg-color': (0, _nukeCore.vLoader)(Core['color-fill1-2']),
    /**
     * border
     * @property namespace statement/disabled
     */
    'second-disabled-border-color': (0, _nukeCore.vLoader)(Core['color-line1-1']),
    /**
     * text
     * @property namespace statement/normal
     */
    'third-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * background
     * @property namespace statement/normal
     */
    'third-bg-color': (0, _nukeCore.vLoader)(Core['color-brand1-9']),
    /**
     * border
     * @property namespace statement/normal
     */
    'third-border-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * text
     * @property namespace statement/selected
     */
    'third-active-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * background
     * @property namespace statement/selected
     */
    'third-active-bg-color': (0, _nukeCore.vLoader)(Core['color-brand1-9']),
    /**
     * border
     * @property namespace statement/selected
     */
    'third-active-border-color': (0, _nukeCore.vLoader)(Core['color-brand1-6']),
    /**
     * text
     * @property namespace statement/disabled
     */
    'third-disabled-color': (0, _nukeCore.vLoader)(Core['color-text1-1']),
    /**
     * background
     * @property namespace statement/disabled
     */
    'third-disabled-bg-color': (0, _nukeCore.vLoader)(Core['color-fill1-2']),
    /**
     * border
     * @property namespace statement/disabled
     */
    'third-disabled-border-color': (0, _nukeCore.vLoader)(Core['color-line1-1']),

    /**
     * border-style
     * @property namespace statement
     */
    'w-line-style': (0, _nukeCore.vLoader)(Core['line-solid']),
    /**
     * text
     * @property namespace statement
     */
    'w-normal-color': (0, _nukeCore.vLoader)(Core['color-error-2']),
    /**
     * background
     * @property namespace statement
     */
    'w-normal-bg-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * border
     * @property namespace statement
     */
    'w-normal-border-color': (0, _nukeCore.vLoader)(Core['color-error-2']),
    /**
     * text
     * @property namespace statement/selected
     */
    'w-normal-active-color': (0, _nukeCore.vLoader)(Core['color-error-2']),
    /**
     * background
     * @property namespace statement/selected
     */
    'w-normal-active-bg-color': (0, _nukeCore.vLoader)(Core['color-error-3']),
    /**
     * border
     * @property namespace statement/selected
     */
    'w-normal-active-border-color': (0, _nukeCore.vLoader)(Core['color-error-2']),

    /**
     * text
     * @property namespace statement
     */
    'w-prim-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * background
     * @property namespace statement
     */
    'w-prim-bg-color': (0, _nukeCore.vLoader)(Core['color-error-2']),
    /**
     * border
     * @property namespace statement
     */
    'w-prim-border-color': (0, _nukeCore.vLoader)(Core['color-error-2']),
    /**
     * text
     * @property namespace statement/active
     */
    'w-prim-active-color': (0, _nukeCore.vLoader)(Core['color-white']),
    /**
     * background
     * @property namespace statement/active
     */
    'w-prim-active-bg-color': (0, _nukeCore.vLoader)(Core['color-error-3']),
    /**
     * border
     * @property namespace statement/active
     */
    'w-prim-active-border-color': (0, _nukeCore.vLoader)(Core['color-error-2']),
    /**
     * text
     * @property namespace statement/disabled
     */
    'w-prim-disabled-color': (0, _nukeCore.vLoader)(Core['color-text1-1']),
    /**
     * background
     * @property namespace statement/disabled
     */
    'w-prim-disabled-bg-color': (0, _nukeCore.vLoader)(Core['color-fill1-2']),
    /**
     * border
     * @property namespace statement/disabled
     */
    'w-prim-disabled-border-color': (0, _nukeCore.vLoader)(Core['color-line1-1']),
    /**
     * text
     * @property namespace statement/disabled
     */
    'w-disabled-color': (0, _nukeCore.vLoader)(Core['color-text1-1']),
    /**
     * background
     * @property namespace statement/disabled
     */
    'w-disabled-bg-color': (0, _nukeCore.vLoader)(Core['color-fill1-2']),
    /**
     * border
     * @property namespace statement/disabled
     */
    'w-disabled-border-color': (0, _nukeCore.vLoader)(Core['color-line1-1']),
    /**
     * size
     * @property namespace size/bounding
     */
    'icon-l-size': (0, _nukeCore.vLoader)(Core['icon-l']),
    /**
     * size
     * @property namespace size/bounding
     */
    'icon-m-size': (0, _nukeCore.vLoader)(Core['icon-m']),
    /**
     * size
     * @property namespace size/bounding
     */
    'icon-s-size': (0, _nukeCore.vLoader)(Core['icon-s']),
    /**
     * height
     * @property namespace size/bounding
     */
    'icon-l-height': (0, _nukeCore.vLoader)(Core['s-10']),
    /**
     * height
     * @property namespace size/bounding
     */
    'icon-m-height': (0, _nukeCore.vLoader)(Core['s-7']),
    /**
     * height
     * @property namespace size/bounding
     */
    'icon-s-height': (0, _nukeCore.vLoader)(Core['s-5']),
    /**
     * group-margin
     * @property namespace size/bounding
     */
    'group-margin': (0, _nukeCore.vLoader)(Core['s-2'])
  };

  // should alway use var statement to carray a assigngg
  var variable = Object.assign(buttonVariables, ComponentCustomStyle);

  return variable;
}

module.exports = VariableMix;