/** @jsx createElement */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeThemeProvider = require('nuke-theme-provider');

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonGroup = function (_Component) {
  _inherits(ButtonGroup, _Component);

  function ButtonGroup() {
    _classCallCheck(this, ButtonGroup);

    return _possibleConstructorReturn(this, (ButtonGroup.__proto__ || Object.getPrototypeOf(ButtonGroup)).apply(this, arguments));
  }

  _createClass(ButtonGroup, [{
    key: 'getButtons',
    value: function getButtons(styles) {
      var buttons = [];
      var _props = this.props,
          block = _props.block,
          children = _props.children;

      children.forEach(function (btn, index) {
        if ((0, _rax.isValidElement)(btn)) {
          buttons.push((0, _rax.cloneElement)(btn, {
            style: Object.assign({}, btn.props.style, block ? styles['group-block-button'] : styles['group-button'], index + 1 === children.length ? styles['group-button-last'] : {})
          }));
        }
      });
      return buttons;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          block = _props2.block,
          _props2$style = _props2.style,
          style = _props2$style === undefined ? {} : _props2$style,
          others = _objectWithoutProperties(_props2, ['block', 'style']);

      var styles = this.props.themeStyle;
      var wrapStyle = Object.assign({}, styles.group, block ? styles['group-block'] : {}, style);
      return (0, _rax.createElement)(
        _nukeView2.default,
        _extends({}, others, { style: wrapStyle }),
        this.getButtons(styles)
      );
    }
  }]);

  return ButtonGroup;
}(_rax.Component);

ButtonGroup.propTypes = {
  rect: _rax.PropTypes.bool,
  block: _rax.PropTypes.bool,
  fixed: _rax.PropTypes.bool,
  style: _rax.PropTypes.any,
  children: _rax.PropTypes.node,
  themeStyle: _rax.PropTypes.object
};
ButtonGroup.defaultProps = {
  rect: false,
  block: false,
  fixed: false,
  shape: 'normal',
  style: {},
  children: {},
  themeStyle: {}
};
ButtonGroup.contextTypes = {
  parentPath: _rax.PropTypes.any,
  parentStyle: _rax.PropTypes.any,
  androidConfigs: _rax.PropTypes.any,
  commonConfigs: _rax.PropTypes.any
};
ButtonGroup.displayName = 'ButtonGroup';

var StyledButtonGroup = (0, _nukeThemeProvider.connectStyle)(_styles2.default)(ButtonGroup);

exports.default = StyledButtonGroup;
module.exports = exports['default'];