'use strict';

import { padding } from 'nuke-core';

function valueToObj(obj) {
  Object.keys(obj).forEach((name) => {
    if (typeof obj[name] === 'object') {
      obj[name] = {
        name,
        raw: obj[name],
      };
    }
  });
  return obj;
}

function buttonColor(color, activeColor, bgColor, activeBgColor, borderColor, activeBorderColor, opacity) {
  return valueToObj(
    Object.assign(
      {
        color,
        backgroundColor: bgColor,
        borderColor,
        'color:active': activeColor,
        'backgroundColor:active': activeBgColor,
        'borderColor:active': activeBorderColor,
      },
      opacity ? { opacity } : {}
    )
  );
}

function buttonSize(pd = 0, height = 0, fontSize = 0, iconSize = 0, iconMargin = 0, corner = 0, borderWidth = 0) {
  return valueToObj({
    height,
    ...padding(0, pd),
    fontSize,
    borderRadius: corner,
    borderWidth,
  });
}

function buttonDisabled(disabledColor, disabledBgColor, disabledBorderColor, disbledOpacity) {
  return valueToObj({
    color: disabledColor,
    backgroundColor: disabledBgColor,
    borderColor: disabledBorderColor,
    opacity: disbledOpacity,
    'color:active': disabledColor,
    'backgroundColor:active': disabledBgColor,
    'borderColor:active': disabledBorderColor,
  });
}

module.exports = {
  buttonColor,
  buttonSize,
  buttonDisabled,
};
